// Justin Chambers
// 03/2018

var particles = [];
var nums;
var particleDensity = 2000;
var noiseScale = 200;
var maxLife = 12;
var	simulationSpeed = 0.2;
var fadeFrame = 0;
var backgroundColor;
var visualMode = 0;
var numModes = 3;
var invertColors = false;
var padding_top = 10;
var divise=12;
var moncanvas;



function setup(){
	nums = windowWidth * windowHeight / particleDensity;
	backgroundColor = color(20, 20, 20);
	moncanvas = createCanvas( windowWidth/2, windowHeight/2);
	//moncanvas.position(windowWidth/4, 0);
	moncanvas.parent("sketch-holder");

	moncanvas.mousePressed(advanceVisual);

	background(backgroundColor);
	for(var i = 0; i < nums; i++){
		particles[i] = new Particle();
	}
}

function draw(){
	noStroke();
	fill(0,7);
	rect(0,0,width,height);
	
/*	++fadeFrame;
	if(fadeFrame % 10 === 0){//5
		if(invertColors){
			blendMode(ADD);
		} else {
			blendMode(DIFFERENCE);
		}
		

		if(invertColors){
			blendMode(DARKEST);
		} else {
			blendMode(LIGHTEST);
		}
		fill(0,7);
		rect(0,0,width,height);
	}
*/	
blendMode(BLEND);
	smooth();
	for(var i = 0; i < nums; i++){
		var iterations = map(i,0,nums,5,12);//map(i,0,nums,5,1);
		var radius = map(i,0,nums,0.2,3);//map(i,0,nums,2,6);
		
		particles[i].move(iterations);
		particles[i].checkEdge();
		
		var alpha = 255;
		var particleColor;
		var fadeRatio;
		//fadeRatio = min(particles[i].life * 12/ maxLife, 1);
		fadeRatio = min(particles[i].life * 20 / maxLife, 100);
		fadeRatio = max((maxLife - particles[i].life) * 2 / maxLife, fadeRatio);
	//	var colorCase = visualMode;
		if(visualMode === 0)
		{
			colorCase = int(particles[i].pos.x / width ) + 1;
			
		}
		switch(colorCase)
		{
			case 1:
				var lifeRatioGrayscale = min(255, (255 * particles[i].life / maxLife) + red(backgroundColor));
				particleColor = color(lifeRatioGrayscale, alpha * fadeRatio);
				break;
			case 2:
				particleColor = particles[i].color;

				break;
			case 3:
				particleColor = color(blue(particles[i].color) + 70, green(particles[i].color) + 20, red(particles[i].color) - 50);
				break;
		}
		if(invertColors){
			particleColor = color(255 - red(particleColor), 255 - green(particleColor), 255 - blue(particleColor));
		}
		fill(red(particleColor), green(particleColor), blue(particleColor), alpha * fadeRatio);
		particles[i].display(radius);
	} 
}

function Particle(){
// member properties and initialization
	this.vel = createVector(0, 0);
//	this.pos = createVector(random(0, width), random(0, height));
this.pos = createVector(0, random(0, height));
	this.life = maxLife;
	//this.life = random(0, maxLife);
	this.flip = int(random(0,0.07)) * 2 - 1;
	//var randColor = int(random(0,3));
	var randColor = int(0);
	switch(randColor)
	{
		case 0:
			this.color = color(110,57,204);
			break;
		case 1:
			this.color = color(110,57,204)
			break;
		case 2:
			this.color = color(110,57,204)
			break;
	}
	
// member functions
	this.move = function(iterations){
		if((this.life -= 0.01666) < 0)//if((this.life -= 0.01666) < 0)
			this.respawn();
		while(iterations > 0){
			var transition = map(this.pos.y, height/divise, height, 0, 1, true);
		//var angle = HALF_PI;
					var angle = noise(this.pos.x/noiseScale, this.pos.y/noiseScale)*transition*TWO_PI*noiseScale*this.flip;
		//	angle += (noise(this.pos.x/noiseScale, this.pos.y/noiseScale)-0.5)*transition*TWO_PI*noiseScale/66;//66
			this.vel.x = cos(angle);
			this.vel.y = sin(angle);
			this.vel.mult(simulationSpeed);
			this.pos.add(this.vel);
			--iterations;
		}
	}

	this.checkEdge = function(){
	//	if(this.pos.x > width || this.pos.x < 0 || this.pos.y > height || this.pos.y < 0){
		  if(this.pos.x > width ){
		   // divise=2;
			this.respawn();
			//	noiseSeed(0.0986*Number.MAX_SAFE_INTEGER);

			
		//	advanceVisual();
		}
	}
	
	this.respawn = function(){
		this.pos.x = random(0, width);//this.pos.x = random(0, width);
		this.pos.y = random(0, height);
		this.life = maxLife;
//divise=2;
	}

	this.display = function(r){
		ellipse(this.pos.x, this.pos.y, r, r);
	}
}

function advanceVisual()
{
	//visualMode = ++visualMode % numModes;
	
	if(visualMode === 0){
	//	invertColors = !invertColors;
	//	backgroundColor = invertColors ? color(235, 235, 235) : color(175, 175, 175);
	}
	noiseSeed(random()*Number.MAX_SAFE_INTEGER);
	//divise=random(5,80);
	//background(backgroundColor);
	// for(var i = 0; i < nums; i++){
	// 	particles[i].respawn();
	// 	particles[i].life = random(0,maxLife);
	// 	//particles[i].life = random(0,maxLife);
 //  }
}



/*function touchStarted()
{
	advanceVisual();
}
*/
